#!/usr/bin/env python

import sys

characterSet = "P0123456789.- \nE"

def convertCharacter(character):
    index = characterSet.find(character)
    if index == -1:
        return 1
    return index

def convertNumberToHexadecimalString(number, numberOfDigits):
    output = hex(number)
    output = output[2:]
    output = output.upper()
    while len(output) < numberOfDigits:
        output = "0" + output
    return output

print "ASCII to DUO Decimal Text Converter"

if len(sys.argv) < 2:
    print "Please provide a file name as an argument."
    sys.exit(0)

tempFile = open(sys.argv[1], "r")
tempText = tempFile.read() + "E"
tempFile.close()

tempData = []
index = 0
while index < len(tempText):
    tempCharacter1 = tempText[index]
    index += 1
    if index < len(tempText):
        tempCharacter2 = tempText[index]
        index += 1
    else:
        tempCharacter2 = "0"
    tempNumber1 = convertCharacter(tempCharacter1)
    tempNumber2 = convertCharacter(tempCharacter2)
    tempData.append(tempNumber1 * 16 + tempNumber2)

tempText = ""
index = 0
while index < len(tempData):
    tempChecksum = 0
    tempLength = 16
    if index + tempLength > len(tempData):
        tempLength = len(tempData) - index
    tempText += ":" + convertNumberToHexadecimalString(tempLength, 2)
    tempChecksum += tempLength
    tempText += convertNumberToHexadecimalString(index, 4) + "00"
    tempChecksum += int(index / 256)
    tempChecksum += index % 256
    tempIndex = 0
    while tempIndex < tempLength:
        tempNumber = tempData[index]
        tempText += convertNumberToHexadecimalString(tempNumber, 2)
        tempChecksum += tempNumber
        index += 1
        tempIndex += 1
    tempText += convertNumberToHexadecimalString((256 - tempChecksum % 256) % 256, 2)
    tempText += "\n"

tempFile = open("./eepromText.hex", "w")
tempFile.write(tempText)
tempFile.close()

print "Converted " + str(len(tempText)) + " bytes to " + str(len(tempData)) + " bytes."
